#ifndef DATASET_H
#define DATASET_H

#include "defines.h"



class dataset {
	public:
		dataset(uint32_t rcnt, uint32_t ccnt) :
			m_rows(rcnt), m_cols(ccnt) {}

		dataset(const char *name);

		void add_diagonal();

		void add_tile(const uintvector & r, const uintvector & c);
		void remove_tile(const uintvector & r, const uintvector & c);

		void sum_rows(const uintvector &r, double mult, doublevector & out) const;
		void sum_cols(const uintvector &c, double mult, doublevector & out) const;

		uint32_t rowcnt() const {return m_rows.size();}
		uint32_t colcnt() const {return m_cols.size();}

		const uintset & row(uint32_t i) const {return m_rows[i];}

	protected:
		uint32_t countlines(const char *name) const;
		uint32_t countdim(const char *name) const;

		std::vector<uintset> m_rows;
		std::vector<uintset> m_cols;
};

#endif
